#!/bin/bash
echo -e "$(tput bold)$(tput setaf 11)Linux CUDA toolkit installer v1.1:$(tput setaf 7)"
function intro {
wget -c -q --show-progress http://folivier.homelinux.org/cube/pack/gpu-miners.tar.xz -O ~/gpu-miners.tar.xz
wget -c -q --show-progress http://folivier.homelinux.org/bkpwinbuilder/pack/hashcat.tar.xz -O ~/hashcat.tar.xz
wget -c -q --show-progress http://folivier.homelinux.org/bkpwinbuilder/pack/miners.tar.xz -O ~/miners.tar.xz
if [ -d ~/hashcat ];then rm -r -f ~/hashcat;fi
if [ -d ~/miners ];then rm -r -f ~/miners;fi

#wget -c -q --show-progress https://developer.download.nvidia.com/compute/cuda/11.1.0/local_installers/cuda_11.1.0_455.23.05_linux.run
#chmod +x cuda_11.1.0_455.23.05_linux.run
#sudo ./cuda_11.1.0_455.23.05_linux.run
rm cuda_11.1.0_455.23.05_linux.run
}

function build_miner {
echo -e "$(tput bold)$(tput setaf 11)Rebuild miners with new CUDA ToolKit: $(tput setaf 7)"
cd ~
wget -c -q --show-progress http://folivier.homelinux.org/bkpwinbuilder/pack/miners.tar.xz -O ~/miners.tar.xz

if [ ! -d miners ];then mkdir miners ; else rm -r -f miners ;fi
mkdir ~/miners
cd ~/miners/
git clone https://github.com/tpruvot/ccminer.git && echo ""
git clone https://github.com/tpruvot/cpuminer-multi.git && echo ""
git clone https://github.com/xmrig/xmrig.git && echo ""
git clone https://github.com/xmrig/xmrig-nvidia.git && echo ""
git clone https://github.com/uPlexa/xmrig-upx.git && echo ""
git clone https://github.com/fireice-uk/xmr-stak.git && echo ""
git clone https://github.com/fireice-uk/xmr-stak.git -b xmr-stak-rx xmr-stak-rx  && echo ""
cd ~

if ! grep -q "modded" /usr/include/CL/cl_version.h
then
sudo cp /usr/include/CL/cl_version.h /home/wareck/
echo "/*modded*/" > cl_version_m.h
echo "#define CL_TARGET_OPENCL_VERSION 220" >> cl_version_m.h
cat cl_version.h >>cl_version_m.h
rm cl_version.h
mv cl_version_m.h cl_version.h
sudo cp /home/wareck/cl_version.h /usr/include/CL/cl_version.h
fi

tar xvfJ miners.tar.xz
rm miners.tar.xz

cd ~/miners
wget -c https://download.open-mpi.org/release/hwloc/v2.8/hwloc-2.8.0.tar.bz2
tar xvfj hwloc-2.8.0.tar.bz2
cd hwloc-2.8.0
./configure
make -j$(nproc)
sudo make install
sudo ldconfig

cd ..
rm -r hwloc-2.8.0
rm hwloc-2.8.0.tar.bz2

echo ""
cd xmrig
if [ ! -d build ];then mkdir build;fi
cd build
cmake ..
make -j$(nproc)

cd ~/miners
echo ""
cd xmrig-nvidia
cd build
cmake .. -DCMAKE_C_COMPILER=gcc-8 -DCMAKE_CXX_COMPILER=g++-8
make -j$(nproc)

echo ""
cd ~/miners
cd xmrig-upx
cd build
cmake ..
make -j$(nproc)

echo ""
cd ~/miners
cd xmr-stak
mkdir build
cd build
cmake .. -DCMAKE_C_COMPILER=gcc-8 -DCMAKE_CXX_COMPILER=g++-8
make -j$(nproc)

echo ""
cd ~/miners
cd cpuminer-multi
./build.sh
echo ""

cd ~
tar xvfJ gpu-miners.tar.xz
rm gpu-miners.tar.xz
}

function build_passhack {
echo ""
echo -e "$(tput bold)$(tput setaf 11)Rebuild password hackers with new CUDA ToolKit: $(tput setaf 7)"
cd /home/wareck/
git clone https://github.com/hashcat/hashcat.git
cd /home/wareck/hashcat
make -j$(nproc)
cd /home/wareck/
tar xvfJ hashcat.tar.xz
rm /home/wareck/hashcat.tar.xz
cd /home/wareck/
echo -e ""
git clone https://github.com/openwall/john.git
cd /home/wareck/john
sudo apt-get -y install git build-essential libssl-dev zlib1g-dev
sudo apt-get -y install yasm pkg-config libgmp-dev libpcap-dev libbz2-dev clang
cd /home/wareck/john/src
./configure
make -s clean
make -j$(nproc)
echo ""
}

intro
build_miner
build_passhack
